class newcamd_client
{
	public:
	newcamd_client(char *server_url, unsigned int timeout, protocol_version_t version = VERSION_525);
	~newcamd_client(void);
	
	// configuration related
	unsigned int status;
	char status_description[128];
	bool process_emms;
	int dbg;
	
	short int user_id;
	unsigned short int card_caid;
	unsigned int card_provider_id[MAX_CARD_PROVIDER_COUNT];
	unsigned short int card_provider_id_count;
	unsigned char cam_id[8];
	unsigned char cardatareq[255];
	int	 cardatalen;
	
	//control words
	unsigned char cw_0[8];
	unsigned char cw_1[8];
	unsigned char echobuf[512];	
	int echobufsize;	
	
	//verbs
	bool is_ready( void );
	void send_ecm(unsigned char *ecm_data, unsigned short int ecm_data_length, unsigned short int sid);
	void send_emm(unsigned char *emm_data, unsigned short int emm_data_length);
	void sendack(void);
	
	private:
	int fd; //file descriptor for network connections.
	triple_des des;
	
	unsigned short int sent_sequence_id;
	unsigned short int received_sequence_id;
	
	bool ready;
	int network_timeout;
	
	protocol_version_t protocol_version;
	unsigned char custom_data[8];
	unsigned short int custom_data_length;
	
	char url[128];
	char hostname[64];
	unsigned int port;
	char username[32];
	char password[32];
	
	// key related
	unsigned char random_key[14];
	unsigned char des_key[14];
	unsigned char login_key[14];
	unsigned char session_key[14];
	
	unsigned char expanded_login_key[16];
	unsigned char expanded_session_key[16];
	
	//misc
	void set_protocol_version( protocol_version_t version );
	void set_sid( unsigned short int sid );
	
	void create_login_key();
	void create_session_key( char *encrypted_password );
	
	void server_connect( void );
	void server_login( void );
	void server_disconnect( void );
	
	void parse_url( void );
	
	//network related
	void send_command( net_msg_type_t command, unsigned char *data, unsigned short int data_length, unsigned char *custom_data, key_encryption_t key_type );
	net_msg_type_t receive_command( unsigned char *custom_data, key_encryption_t key_type );
	void send_message(unsigned char *message, unsigned short int length, unsigned char *custom_data, key_encryption_t key_type );
	int receive_message(unsigned char *message, unsigned char *custom_data, key_encryption_t key_type );
	int network_write(unsigned char *buffer, unsigned int length);
	int network_read(unsigned char *buffer, unsigned int length, int override_timeout = -1);

	
	void debug_output(unsigned char *buffer, unsigned int length, char *header);
};

